package com.madeu.controller.web.webtreatmentpetit;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.ModelAndView;

import com.madeu.constants.Constants;
import com.madeu.common.service.LogHistoryService;
import com.madeu.service.web.webtreatmentpetit.WebTreatmentPetitService;
import com.madeu.util.HttpUtil;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Controller
public class WebTreatmentPetitController {

    @Autowired
    private WebTreatmentPetitService webTreatmentPetitService;

    @Autowired
	private LogHistoryService logHistoryService;

    /**
     * 홈페이지 시술예약(쁘띠) 리스트 화면으로 이동.
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webtreatmentpetit/selectListWebTreatmentPetitIntro.do")
    public String  selectListWebTreatmentPetitIntro(HttpSession session, HttpServletRequest request, HttpServletResponse response, Model model) {
        log.debug("WebTreatmentPetitController  selectListWebTreatmentPetitIntro START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
            map = webTreatmentPetitService.selectListWebTreatmentPetitIntro(paramMap);

            model.addAttribute("selectUseYn", map.get("selectUseYn"));
            model.addAttribute("insertUseYn", map.get("insertUseYn"));
            model.addAttribute("updateUseYn", map.get("updateUseYn"));
            model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
            model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
        }
        catch (Exception e) {
            e.printStackTrace();
            return "/web/login/logout";
        }
        log.debug("WebTreatmentPetitController  selectListWebTreatmentPetitIntro END");
        return "/web/webtreatmentpetit/webTreatmentPetitSelectList";
    }

    /**
     * 홈페이지 시술예약(쁘띠) 정보 리스트 조회
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webtreatmentpetit/selectListWebTreatmentPetit.do")
    public ModelAndView selectListWebTreatmentPetit(HttpSession session, HttpServletRequest request, HttpServletResponse response) {
        log.debug("WebTreatmentPetitController selectListWebTreatmentPetit START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
            map = webTreatmentPetitService.selectListWebTreatmentPetit(paramMap);
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("WebTreatmentPetitController selectListWebTreatmentPetit END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 홈페이지 시술예약(쁘띠) 정보 상세 조회
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webtreatmentpetit/selectWebTreatmentPetit.do")
    public ModelAndView selectWebTreatmentPetit(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
        log.debug("WebTreatmentPetitController selectWebTreatmentPetit START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
            map = webTreatmentPetitService.selectWebTreatmentPetit(paramMap);
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("WebTreatmentPetitController selectWebTreatmentPetit END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 홈페이지 시술예약(쁘띠) 상세 이미지 파일 저장
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webtreatmentpetit/uploadFile.do")
    public ModelAndView uploadFile(HttpSession session,HttpServletRequest request, HttpServletResponse response,@RequestParam(value = "file", required = false) MultipartFile file) {
        log.debug("WebTreatmentPetitController uploadFile START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try{
            paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
            paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
            paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
            map = webTreatmentPetitService.uploadFile(paramMap,file);
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            			logHistoryService.save("홈페이지 시술예약(쁘띠) 상세 이미지파일 저장", "홈페이지 시술예약(쁘띠) 등록", paramMap, map, String.valueOf(errorMsg));
        }
        log.debug("WebTreatmentPetitController uploadFile END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }
    
    /**
     * 홈페이지 시술예약(쁘띠) 등록 화면으로 이동.
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webtreatmentpetit/insertWebTreatmentPetitIntro.do")
    public String  insertWebTreatmentPetitIntro(HttpSession session, HttpServletRequest request, HttpServletResponse response, Model model) {
        log.debug("WebTreatmentPetitController  insertWebTreatmentPetitIntro START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
            map = webTreatmentPetitService.insertWebTreatmentPetitIntro(paramMap);

            model.addAttribute("selectUseYn", map.get("selectUseYn"));
            model.addAttribute("insertUseYn", map.get("insertUseYn"));
            model.addAttribute("updateUseYn", map.get("updateUseYn"));
            model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
            model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
            model.addAttribute("categorylist", map.get("categorylist"));
        }
        catch (Exception e) {
            e.printStackTrace();
            return "/web/login/logout";
        }
        log.debug("WebAppContentsController  insertWebTreatmentPetitIntro END");
        return "/web/webtreatmentpetit/webTreatmentPetitInsert";
    }

    /**
     * 홈페이지 시술예약(쁘띠) 정보 등록
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webtreatmentpetit/insertWebTreatmentPetit.do")
    public ModelAndView insertWebTreatmentPetit(HttpSession session,HttpServletRequest request, HttpServletResponse response,@RequestParam(value = "file", required = false) MultipartFile file,@RequestParam(value = "content_file", required = false) MultipartFile content_file) {
        log.debug("WebTreatmentPetitController insertWebTreatmentPetit START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try{
            paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
            paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
            paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
            map = webTreatmentPetitService.insertWebTreatmentPetit(paramMap,file,content_file);
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            			logHistoryService.save("홈페이지 시술예약(쁘띠) 등록", "홈페이지 시술예약(쁘띠) 등록", paramMap, map, String.valueOf(errorMsg));
        }
        log.debug("WebTreatmentPetitController insertWebTreatmentPetit END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 홈페이지 시술예약(쁘띠) 수정 화면으로 이동.
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webtreatmentpetit/updateWebTreatmentPetitIntro.do")
    public String  updateWebTreatmentPetitIntro(HttpSession session, HttpServletRequest request, HttpServletResponse response, Model model) {
        log.debug("WebTreatmentPetitController  updateWebTreatmentPetitIntro START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
            map = webTreatmentPetitService.updateWebTreatmentPetitIntro(paramMap);

            model.addAttribute("selectUseYn", map.get("selectUseYn"));
            model.addAttribute("insertUseYn", map.get("insertUseYn"));
            model.addAttribute("updateUseYn", map.get("updateUseYn"));
            model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
            model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
            model.addAttribute("category", map.get("category"));
        }
        catch (Exception e) {
            e.printStackTrace();
            return "/web/login/logout";
        }
        log.debug("WebAppContentsController  updateWebTreatmentPetitIntro END");
        return "/web/webtreatmentpetit/webTreatmentPetitUpdate";
    }

    /**
     * 홈페이지 시술예약(쁘띠) 정보 수정
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webtreatmentpetit/updateWebTreatmentPetit.do")
    public ModelAndView updateWebTreatmentPetit(HttpSession session,HttpServletRequest request, HttpServletResponse response, @RequestParam(value = "file", required = false) MultipartFile file, @RequestParam(value = "content_file", required = false) MultipartFile content_file) {
        log.debug("WebTreatmentPetitController updateWebTreatmentPetit START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try{
            paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
            paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
            paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
            map = webTreatmentPetitService.updateWebTreatmentPetit(paramMap, file, content_file );
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            			logHistoryService.save("홈페이지 시술예약(쁘띠) 수정", "홈페이지 시술예약(쁘띠) 수정", paramMap, map, String.valueOf(errorMsg));
        }
        log.debug("WebTreatmentPetitController updateWebTreatmentPetit END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }


    /**
     * 홈페이지 시술예약(쁘띠) 정보 삭제
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value="/webtreatmentpetit/deleteWebTreatmentPetit.do")
    public ModelAndView deleteWebTreatmentPetit(@RequestBody HashMap<String, Object> paramMap, HttpSession session, HttpServletRequest request, HttpServletResponse response) {
        log.debug("WebTreatmentPetitController deleteWebTreatmentPetit START");

        //HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();
        
        
        
        try{
            paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
            paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
            paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
            map = webTreatmentPetitService.deleteWebTreatmentPetit(paramMap);
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            			logHistoryService.save("홈페이지 시술예약(쁘띠) 삭제", "홈페이지 시술예약(쁘띠) 삭제", paramMap, map, String.valueOf(errorMsg));
        }
        log.debug("WebTreatmentPetitController deleteWebTreatmentPetit END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }
    
    /**
     * 시술 정보 리스트 조회 (option)
     * 시술등록 팝업
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/webtreatmentpetit/selectListTreatmentOption.do")
    public ModelAndView selectListTreatmentOption(HttpSession session, HttpServletRequest request, HttpServletResponse response) {
        log.debug("WebTreatmentPetitController selectListTreatmentOption START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try {
            paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
            map = webTreatmentPetitService.selectListTreatmentOption(paramMap);
        }
			catch (Exception e) {
            e.printStackTrace();
            return null;
        } finally {
            if (Constants.OK == map.get("msgCode")) {

            } else {
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if (null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc", "정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("WebTreatmentPetitController selectListTreatmentOption END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }
    
}


